-- Begin of Target Class
Target = {}
Target.__index = Target

function Target:new(handle, name, app, options)
	local obj = {}
	setmetatable(obj, Target)
	obj.handle = handle
	obj.name = name
	obj.appearance = app
	obj.options = options or nil
	return obj
end
-- End of Target Class

-- Begin of NPCAppMod Class

NPCAppMod = {}
NPCAppMod.__index = NPCAppMod

function NPCAppMod:new()
   local obj = {}
   setmetatable(obj, self)
   obj.npcs = {
   	judy = {'judy__q203__shower', 'judy_braindance_off', 'judy_braindance_on', 'judy_default', 'judy_default__no_makeup', 'judy_diving_suit', 'judy_diving_suit_mask', 'judy_nude', 'judy_panties'},
	panam = {'panam__q203__after_shower', 'panam__q203__shower', 'panam_default', 'panam_default_scars', 'panam_default_wounded', 'panam_no_jacket', 'panam_no_jacket_and_harness', 'panam_nude', 'panam_underwear'},
	rogue = {'rogue_rogue_date', 'rogue_rogue_date_nojacket', 'rogue_rogue_old', 'rogue_rogue_old_solo', 'rogue_rogue_old_solo_thrusters', 'rogue_rogue_young', 'rogue_rogue_young_2013', 'rogue_rogue_young_cyberspace'},
	stout = {'meredith_stout_bdsm', 'meredith_stout_bdsm_no_pants', 'meredith_stout_default'},
	jackie = {'jackie_welles_default','jackie_welles_default_collar_down','jackie_welles_default_no_machete','jackie_welles_valentino','jackie_welles_valentino_beaten_up','jackie_welles_valentino_beaten_up_alt','jackie_welles_valentino_collar_down','jackie_welles_wounded','jackie_welles_wounded_bleeding','jackie_welles__q000_lizzies_club_no_jacket','jackie_welles__q000_lizzies_club_no_machete','jackie_welles__q005_suit','jackie_welles__q005_suit_bleeding','jackie_welles__q005_suit_dirty','jackie_welles__q005_suit_wounded'},
	evelyn = {'evelyn_braindance','evelyn_dead','evelyn_default','evelyn_disguised','evelyn_no_coat','evelyn_recovering','evelyn_wounded'},
	river = {'river_ward_default', 'river_ward_jail_overalls','river_ward_naked','river_ward_no_jacket','river_ward_underwear','river_ward__q203__shower'},  
	kerry = {'kerry_eurodyne_kerry_eurodyne_bathrobe','kerry_eurodyne_kerry_eurodyne_old','kerry_eurodyne_kerry_eurodyne_old_no_sunglasses','kerry_eurodyne_kerry_eurodyne_undercover','kerry_eurodyne_kerry_eurodyne_undercover_backstage_pass','kerry_eurodyne_kerry_eurodyne_undercover_no_glasses','kerry_eurodyne_kerry_eurodyne_undercover_no_glasses_backstage_pass','kerry_eurodyne_kerry_eurodyne_undress_01','kerry_eurodyne_kerry_eurodyne_undress_02','kerry_eurodyne_kerry_eurodyne_undress_03','kerry_eurodyne_kerry_eurodyne_young','kerry_eurodyne_kerry_eurodyne_young_2013','kerry_eurodyne_nude','kerry_eurodyne__q203__shower'},
	takemura = {'goro_takemura_finale_white','goro_takemura_ronin_shirt','goro_takemura_ronin_trench','goro_takemura_saburo_bodyguard'},
	denny = {'denny_2020_rockergirl','denny_2077_housewife','denny_2077_rockergirl','denny_denny','denny_denny_2020','denny_denny_2077_rockergirl'},
	jackie = {'jackie_welles_default','jackie_welles_default_collar_down','jackie_welles_default_no_machete','jackie_welles_hologram', 'jackie_welles_valentino','jackie_welles_valentino_beaten_up','jackie_welles_valentino_beaten_up_alt','jackie_welles_valentino_collar_down','jackie_welles_wounded','jackie_welles_wounded_bleeding','jackie_welles__q000_lizzies_club_no_jacket','jackie_welles__q000_lizzies_club_no_machete','jackie_welles__q005_suit','jackie_welles__q005_suit_bleeding','jackie_welles__q005_suit_dirty','jackie_welles__q005_suit_wounded' },
	claire = {'clair_bartender','clair_default'},
	tbug = {'t_bug_casual','t_bug_default'}
	}
   return obj
end

function NPCAppMod:GetNPCName(t)
	n = t:GetTweakDBDisplayName(true)
	return n
end

function NPCAppMod:GetClothingOptions(t)
	npcName = t:GetTweakDBDisplayName(true):lower()
	if self.npcs[npcName] ~= nil then
		return self.npcs[npcName] -- array of appearances names
	else
		return nil
	end
end

function NPCAppMod:GetNPCAppearance(t)
	currentApp = t:GetCurrentAppearanceName()
	appStr = string.sub(tostring(currentApp), 57)
	return string.gsub(appStr, " --]] }", "")
end

function NPCAppMod:ChangeNPCAppearanceTo(t, newAppearance)
	t:ScheduleAppearanceChange(newAppearance)
end

-- End of NPCAppMod Class

NPCApp = NPCAppMod:new()
onOpenDebug = false

function NewTarget()
	target = Game.GetTargetingSystem():GetLookAtObject(Game.GetPlayer(),false,false)
	if target ~= nil then
		if target:IsNPC() then
			return Target:new(target, NPCApp:GetNPCName(target),NPCApp:GetNPCAppearance(target), NPCApp:GetClothingOptions(target))
		end
	end

	return 'No NPC'
end

registerForEvent("onUpdate", function()
	if (GetAsyncKeyState(0x73)) then -- Press F4
	    if(onOpenDebug) then
	    	onOpenDebug = false
	    else
	    	onOpenDebug = true
	    end
	end

	if(onOpenDebug) then
		-- Target Setup --
		target = NewTarget()

		ImGui.SetNextWindowPos(500, 500, ImGuiCond.FirstUseEver)
		if target.options ~= nil then
			ImGui.SetNextWindowSize(400, 300)
		else
			ImGui.SetNextWindowSize(400, 120)
		end

	    if (ImGui.Begin("Appearance Menu Mod")) then
			ImGui.SetWindowFontScale(1.2)
			ImGui.PushStyleColor(ImGuiCol.Border, 1, 0, 0, 1)

			if target ~= 'No NPC' then
	    		ImGui.TextColored(1, 0, 0, 1,"Current Appearance:")
	    		ImGui.Text(target.appearance)

	    		if (ImGui.Button("Cycle Appearance")) then
	    			NPCApp:ChangeNPCAppearanceTo(target.handle, 'Cycle')
	    		end
	    	else
	    		ImGui.TextColored(1, 0, 0, 1, "No NPC Found! Look at NPC to begin")
	    	end

	    	ImGui.NewLine()

	    	if target.options ~= nil then
	    		ImGui.TextColored(1, 0, 0, 1, target.name)
		    	if (ImGui.BeginChild("Scrolling")) then
			    	for i, appearance in ipairs(target.options) do
			    		if (ImGui.Button(appearance)) then
			    			NPCApp:ChangeNPCAppearanceTo(target.handle, appearance)
			    		end
			    	end
			    end

			    ImGui.EndChild()
		    end
		end
	    ImGui.End()
	end
end)

